package test.test;

import java.io.IOException;
import java.util.List;
import java.util.Locale;

import website.company.vo.UsedInfoVO;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Point;
import android.location.Address;
import android.location.Geocoder;
import android.location.LocationListener;
import android.location.LocationManager;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Bundle;
import android.telephony.TelephonyManager;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.view.animation.AnimationUtils;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.Toast;
import android.widget.ViewFlipper;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;
import com.google.android.maps.Projection;

public class CopyOfStart2 extends MapActivity {

	MapView goToPsgmap;
	MapController mapCon;
	List<Overlay> overlays;
	LocationManager locaManager;
	TaxiLocation taxiLoca;
	
	String tel, passenger;
	UsedInfoVO readVO;
	UsedInfoVO changedVO = new UsedInfoVO();
	LocationListener locaListener;
	TCPClient client = new TCPClient();

	PassengerOver psnOver ;
	ImageButton callBtn;
	ImageButton getOffBtn;
	ViewFlipper mFlipper;
	GeoPoint myTaxiLoca ;

	Thread sendUpdateThread;
	Boolean flag = true;

	public void sendUpdate(){
		while(flag){
			if(taxiLoca.getMyLocation()==null){
				changedVO.setLatitude(getIntent().getSerializableExtra("lati")+"");
				changedVO.setLongitude(getIntent().getSerializableExtra("longi")+"");
				changedVO.setMsg("update");
				changedVO.setUsedInfoMachingNum(readVO.getUsedInfoMachingNum());

				client.setVo(changedVO);
				client.run();
			}else{
				myTaxiLoca = taxiLoca.getMyLocation();
				changedVO.setLatitude(myTaxiLoca.getLatitudeE6()+"");
				changedVO.setLongitude(myTaxiLoca.getLongitudeE6()+"");
				changedVO.setMsg("update");
				changedVO.setUsedInfoMachingNum(readVO.getUsedInfoMachingNum());
				client.setVo(changedVO);
				client.run();
			}
		}
	}// end of sendUpdate() class


	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {

		requestWindowFeature(Window.FEATURE_NO_TITLE);

		super.onCreate(savedInstanceState);
		setContentView(R.layout.start2);
		//인텐트로 매칭된 승객의 데이터받음.
		readVO = (UsedInfoVO)getIntent().getSerializableExtra("matchingPsg");

		//전화걸기
		passenger = readVO.getUsedInfoPhone();
		callBtn = (ImageButton)findViewById(R.id.callBtn);
		callBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				Intent intent = new Intent(Intent.ACTION_DIAL, Uri.parse("tel:"+passenger));
				startActivity(intent);
			}
		});	    

		getOffBtn = (ImageButton)findViewById(R.id.getOffBtn);
		goToPsgmap = (MapView)findViewById(R.id.goToPsgmap);
		mapCon = goToPsgmap.getController();
		overlays = goToPsgmap.getOverlays();
		goToPsgmap.setBuiltInZoomControls(true);

		mFlipper = (ViewFlipper)findViewById(R.id.flipper2);
		mFlipper.setInAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_in));
		mFlipper.setOutAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_out));
		mFlipper.startFlipping();

		//내 전화번호
		TelephonyManager telManager = (TelephonyManager) getSystemService(TELEPHONY_SERVICE);
		tel = telManager.getLine1Number();

		//passenger's location overlay
		//Drawable psn = getResources().getDrawable(R.drawable.icon);
		//Drawable psn = getApplicationContext().getResources().getDrawable(R.drawable.passenger);
		psnOver = new PassengerOver();
		overlays.add(psnOver);	
		goToPsgmap.postInvalidate();

		taxiLoca = new TaxiLocation(CopyOfStart2.this, goToPsgmap);

		MediaPlayer mPlayer = MediaPlayer.create(CopyOfStart2.this, R.raw.successmatching);
		mPlayer.seekTo(0);
		mPlayer.start();

		taxiLoca.runOnFirstFix(new Runnable() {

			public void run() {
				//	mapCon.setCenter(taxiLoca.getMyLocation());
				mapCon.animateTo(taxiLoca.getMyLocation());
				overlays.add(taxiLoca);	
			}
		});

		//하차버튼
		Button.OnClickListener clickListener = new Button.OnClickListener(){
			public void onClick(View v) {
				new AlertDialog.Builder(CopyOfStart2.this)
				.setTitle("확인")
				.setIcon(R.drawable.endicon)
				.setMessage("정말 종료하시겠습니까")
				.setPositiveButton("종료", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int which) {
						MediaPlayer mPlayer1 = MediaPlayer.create(CopyOfStart2.this, R.raw.soundtaxibyebye);
						mPlayer1.seekTo(0);
						mPlayer1.start();
						UsedInfoVO vo = new UsedInfoVO();
						List<Address> addrs;

						vo.setUsedInfoMachingNum(readVO.getUsedInfoMachingNum());
						vo.setMsg("taxiEnd");
						//하차 시점에 주소넣기				
						try {
							Geocoder coder = new Geocoder(CopyOfStart2.this, Locale.KOREAN);
							//	addrs = coder.getFromLocation(37.4910, 127.0245, 1);
							addrs = coder.getFromLocation(taxiLoca.getLastFix().getLatitude(), taxiLoca.getLastFix().getLongitude(), 1);
							String arrivalAddr = addrs.get(0).getAddressLine(0);
							vo.setUsedInfoDestination(null);

						} catch (Exception e) {
							e.printStackTrace();
						}

						TCPClient client2 = new TCPClient();
						client2.setVo(vo);
						client2.run();

						try {
							Start1.in.close();
							Start1.out.close();
							Start1.socket.close();

						} catch (IOException e) {
							e.printStackTrace();
						}

						finish();

					}
				})
				.setNegativeButton("취소", null)
				.show();

			}
		};

		getOffBtn.setOnClickListener(clickListener);
		sendUpdateThread = new Thread(new Runnable() {
			@Override
			public void run() {
				sendUpdate();
			}
		});
		sendUpdateThread.start();

	}// end of onCreate()

	//MyLocation
	private class TaxiLocation extends MyLocationOverlay{

		public TaxiLocation(Context arg0, MapView arg1) {
			super(arg0, arg1);
		}

		@Override
		protected boolean dispatchTap() {

			Toast.makeText(CopyOfStart2.this, "현재 위치입니다.", Toast.LENGTH_SHORT);

			return super.dispatchTap();
		}

		@Override
		public GeoPoint getMyLocation() {
			return super.getMyLocation();
		}

	}// end of TaxiLocation

	private class PassengerOver extends Overlay{

		@Override
		public void draw(Canvas canvas, MapView mapView, boolean shadow) {
			super.draw(canvas, mapView, shadow);

			Paint pnt = new Paint();
			Bitmap bit;
			Point pt;

			pnt.setAntiAlias(true);
			Projection projection;
			projection = mapView.getProjection();
			GeoPoint psnGeo = new GeoPoint(Integer.parseInt(readVO.getLatitude()),Integer.parseInt(readVO.getLongitude()));

			bit = BitmapFactory.decodeResource(getResources(), R.drawable.passenger);
			pt = projection.toPixels(psnGeo, null);
			canvas.drawBitmap(bit, pt.x, pt.y, pnt);
		}

		@Override
		public boolean onTap(GeoPoint p, MapView mapView) {

			Toast.makeText(CopyOfStart2.this, "승객의 위치입니다.", Toast.LENGTH_SHORT);
			return false;
		}

	}// end of PassengerOver() class

	private class TCPClient implements Runnable{
		UsedInfoVO vo;

		public UsedInfoVO getVo() {
			return vo;
		}

		public void setVo(UsedInfoVO vo) {
			this.vo = vo;
		}

		public void run() {
			try {
				System.out.println(vo.getMsg());
				Start1.out.writeObject(vo);
				Start1.out.reset();
				Start1.out.flush();

				Thread.currentThread().sleep(10000);	
			} catch (IOException e) {
				e.printStackTrace();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}

	}

	@Override
	protected void onResume() {
		super.onResume();
		taxiLoca.enableCompass();
		taxiLoca.enableMyLocation();
	}

	@Override
	protected void onPause() {
		super.onPause();

		flag = false;

		if(Start1.in != null){
			try {
				Start1.in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		if(Start1.out !=null){
			UsedInfoVO vo = new UsedInfoVO();
			List<Address> addrs;

			vo.setUsedInfoMachingNum(readVO.getUsedInfoMachingNum());
			vo.setMsg("taxiEnd");
			//하차 시점에 주소넣기			
			try {
				Geocoder coder = new Geocoder(CopyOfStart2.this, Locale.KOREAN);
				addrs = coder.getFromLocation(taxiLoca.getLastFix().getLatitude(), taxiLoca.getLastFix().getLongitude(), 1);
				String arrivalAddr = addrs.get(0).getAddressLine(0);
				System.out.println("Destination----------------:"+arrivalAddr);
				vo.setUsedInfoDestination(arrivalAddr);

			} catch (IOException e) {
				e.printStackTrace();
			}

			try {
				Start1.out.writeObject(vo);
				Start1.out.reset();
				Start1.out.flush();
				try {
					Thread.currentThread().sleep(5000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				Start1.out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}

		}

		if(Start1.socket != null){
			try {
				Start1.socket.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

	}

	@Override
	protected boolean isRouteDisplayed() {
		return false;
	}

	@Override
	public void onBackPressed() {

	}

}
