package test.test;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import website.company.vo.UsedInfoVO;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.LocationManager;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.telephony.TelephonyManager;
import android.view.View;
import android.view.Window;
import android.view.animation.AnimationUtils;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ViewFlipper;

import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;

public class Start1 extends MapActivity {

	public static Socket socket;
	public static ObjectOutputStream out; 
	public static ObjectInputStream in;

	MapView mapview;
	Handler handler1, handler2, handler3, handler4;
	List<Overlay> overlays = new ArrayList<Overlay>();
	TaxiLocation taxiLoca;
	Geocoder coder;

	String taxiAddr;
	String taxiTel;
	TelephonyManager telManager;
	LocationManager loManager;
	UsedInfoVO readVO = null;

	MapController con; 
	boolean check = true;
	AlertDialog.Builder dia;
	AlertDialog dia2;

	ImageButton registBtn;
	ViewFlipper waitText;
	ImageButton cancleBtn;
	TextView underLine;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {

		//타이틀 없애기
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		super.onCreate(savedInstanceState);
		setContentView(R.layout.start1);

		registBtn = (ImageButton)findViewById(R.id.emptyTaxi);
		mapview = (MapView)findViewById(R.id.matchedmaps);
		mapview.setBuiltInZoomControls(true);
		con = mapview.getController();

		waitText = (ViewFlipper)findViewById(R.id.flipper);
		waitText.setInAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_in));
		waitText.setOutAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_out));
		waitText.startFlipping();

		underLine = (TextView) findViewById(R.id.underLine);

		cancleBtn = (ImageButton)findViewById(R.id.cancel);
		loManager = (LocationManager) getSystemService(LOCATION_SERVICE);

		Criteria cri = new Criteria();
		cri.setAltitudeRequired(true);
		cri.setAccuracy(Criteria.ACCURACY_FINE);
		cri.setBearingRequired(true);

		String bestProvider = loManager.getBestProvider(cri, true);

		//	    con.setCenter(new GeoPoint(37501353, 127031917));
		con.setZoom(17);

		taxiLoca = new TaxiLocation(Start1.this, mapview);

		overlays = mapview.getOverlays();
		overlays.add(taxiLoca);		

		taxiLoca.runOnFirstFix(new Runnable() {
			public void run() {
				con.animateTo(taxiLoca.getMyLocation());
			}
		});


		telManager = (TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);
		taxiTel = telManager.getLine1Number();
		System.out.println("tel:"+taxiTel);

		// 빈차 등록 버튼
		registBtn.setOnClickListener(new Button.OnClickListener() {
			public void onClick(View v) {
				MediaPlayer mPlayer = MediaPlayer.create(Start1.this, R.raw.soundregistemptytaxi);
				mPlayer.seekTo(0);
				mPlayer.start();

				try {
					TCPClient client = new TCPClient(taxiLoca.getMyLocation().getLatitudeE6(),
							taxiLoca.getMyLocation().getLongitudeE6(), taxiTel);

					//	TCPClient client = new TCPClient(37475165,	126995773, taxiTel);

					waitText.setVisibility(View.VISIBLE);
					underLine.setVisibility(View.VISIBLE);
					cancleBtn.setVisibility(View.VISIBLE);
					registBtn.setVisibility(View.INVISIBLE);

				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});

		// 빈차 취소 버튼
		cancleBtn.setOnClickListener(new Button.OnClickListener(){

			public void onClick(View v) {
				MediaPlayer mPlayer1 = MediaPlayer.create(Start1.this, R.raw.soundcancleregist);
				mPlayer1.seekTo(0);
				mPlayer1.start();

				// 연결 끊기 전에 서버로 빈차맵에서 remove요청해야함.
				handler4.sendEmptyMessage(0);

				finish();
			}
		});

		handler4 = new Handler(){

			@Override
			public void handleMessage(Message msg) {
				super.handleMessage(msg);
				try {
					new SendClient3("cancel").run();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		};


	}// end of onCreate()

	private class TaxiLocation extends MyLocationOverlay{

		public TaxiLocation(Context arg0, MapView arg1) {
			super(arg0, arg1);
		}

		@Override
		protected boolean dispatchTap() {

			Toast.makeText(Start1.this, "현재 위치입니다.", Toast.LENGTH_SHORT);
			return super.dispatchTap();
		}

	}


	private class TCPClient{

		private static final String serverIP = "61.106.60.79";
		private static final int serverPort = 8888;

		public TCPClient(int latitude, int longitude, String usedInfoPhone) throws Exception{
			InetAddress serverAddr = InetAddress.getByName(serverIP);
			socket = new Socket(serverAddr.getHostAddress(), serverPort);

			UsedInfoVO vo = new UsedInfoVO();
			vo.setLatitude(latitude+"");
			vo.setLongitude(longitude+"");
			// vo.setUsedInfoCarNum("aaaa");
			vo.setUsedInfoPhone(usedInfoPhone);
			vo.setMsg("registEmptyTaxi");

			out = new ObjectOutputStream(socket.getOutputStream());
			in = new ObjectInputStream(socket.getInputStream());

			new Thread(new SendClient(vo)).start();

			handler1 = new Handler(){

				@Override
				public void handleMessage(Message msg) {
					super.handleMessage(msg);

					dia = new AlertDialog.Builder(Start1.this);
					dia.setMessage("매칭하시겠습니까?");
					dia.setTitle("호출");
					dia.setPositiveButton(R.string.yes, new DialogInterface.OnClickListener() {

						public void onClick(DialogInterface dialog, int which) {
							handler2.sendEmptyMessage(0);
							check = false;
						};
					});

					dia.setNegativeButton("No", new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int which) {

							handler3.sendEmptyMessage(0);
							check = false;
							dialog.dismiss();

						}
					});

					dia2 = dia.show();				

				}};


				handler2 = new Handler(){
					@Override
					public void handleMessage(Message msg) {
						super.handleMessage(msg);
						new SendClient2("yes").run();

						Intent waitIntent = new Intent(Start1.this, CopyOfStart2.class);
						waitIntent.putExtra("matchingPsg", readVO);
						waitIntent.putExtra("lati", taxiLoca.getMyLocation().getLatitudeE6());
						waitIntent.putExtra("longi",taxiLoca.getMyLocation().getLongitudeE6());
						startActivity(waitIntent);
						finish();
					}		
				};


				handler3 = new Handler(){
					@Override
					public void handleMessage(Message msg) {
						super.handleMessage(msg);
						new SendClient2("no").run();
					}
				};

		}// end of TCPClient constructor

	}// end of TCPClient class


	public class SendClient implements Runnable{

		private UsedInfoVO vo;

		public SendClient(UsedInfoVO vo){

			this.vo = vo;
		}

		public void run() {

			try {
				out.writeObject(vo);
				out.reset();
				out.flush();
				System.out.println("**************EmptyTaxiRegist***********");	

				Looper.prepare();

				readVO = (UsedInfoVO)in.readObject();

				System.out.println("matchingnum44444444444:"+readVO.getUsedInfoMachingNum());
				System.out.println(readVO.getUsedInfoPhone());
				System.out.println("----lat---:"+readVO.getLatitude());
				System.out.println("----long--:"+readVO.getLongitude());
				if(readVO.getMsg().equals("how")){

					MediaPlayer mPlayer2 = MediaPlayer.create(Start1.this, R.raw.soundcall);
					mPlayer2.seekTo(0);
					mPlayer2.start();

					handler1.sendEmptyMessage(0);

					int i=0;
					while(i<10){
						Thread.currentThread().sleep(1000);
						i++;
					}

					if(check== true){
						handler3.sendEmptyMessage(0);
						dia2.dismiss();

					}
				}

				Looper.loop();			

			} catch (Exception e) {
				e.printStackTrace();
			}			

		}

	}// end of SendClient


	public class SendClient2 implements Runnable{

		private UsedInfoVO vo = new UsedInfoVO();

		public SendClient2(String msg){

			vo.setMsg(msg);
			//	vo.setLatitude("37501353");
			//	vo.setLongitude("127031917");
			vo.setLatitude(taxiLoca.getMyLocation().getLatitudeE6()+"");
			vo.setLongitude(taxiLoca.getMyLocation().getLongitudeE6()+"");
			vo.setUsedInfoPhone(taxiTel);
			//  vo.setUsedInfoCarNum("bbbb");

		}

		public void run() {
			try {
				out.writeObject(vo);
				out.reset();	
				out.flush();

				String matchingStr = in.readUTF();
				
				if(matchingStr.equals("fail")){
					vo.setMsg("cancel");
					vo.setUsedInfoPhone(taxiTel);

					try {
						out.writeObject(vo);
						out.reset();
						out.flush();
					} catch (Exception e) {
						e.printStackTrace();
					}finally{
						out.close();
						in.close();
						socket.close();
					}
					
					finish();
				}

				readVO.setUsedInfoMachingNum(matchingStr);

			} catch (Exception e) {
				e.printStackTrace();
			}			

		}
	}// end of SendClient2 class

	
	//하차버튼
	public class SendClient3 implements Runnable{

		private static final String serverIP = "61.106.60.79";
		private static final int serverPort = 8888;
		private UsedInfoVO vo = new UsedInfoVO();
		private Socket socket;
		private ObjectOutputStream out;

		public SendClient3(String msg) throws IOException{

			InetAddress serverAddr = InetAddress.getByName(serverIP);
			socket = new Socket(serverAddr.getHostAddress(), serverPort);
			out = new ObjectOutputStream(socket.getOutputStream());

			vo.setMsg(msg);
			vo.setUsedInfoPhone(taxiTel);
			System.out.println(vo.getMsg());
		}

		public void run() {
			try {
				out.writeObject(vo);
				out.reset();
				out.flush();

				System.out.println("Send Cancle-------------");

			} catch (Exception e) {
				e.printStackTrace();
			}finally{
				try {
					out.close();
					in.close();
					socket.close();					
				} catch (IOException e) {
					e.printStackTrace();
				}

			}

		}

	}// end of SendClient3 class

	@Override
	protected void onPause() {
		super.onPause();
		taxiLoca.disableMyLocation();
		taxiLoca.disableCompass();
	}

	@Override
	protected void onResume() {
		super.onResume();
		taxiLoca.enableMyLocation();
		taxiLoca.enableCompass();
	}

	@Override
	protected boolean isRouteDisplayed() {
		return false;
	}

}