package test.test;

import android.app.*;
import android.content.*;
import android.media.*;
import android.net.*;
import android.os.Bundle;
import android.view.*;
import android.view.View.OnClickListener;
import android.widget.*;

public class TaxiApp extends Activity {

	private MediaPlayer mPlayer;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {

		//타이틀 없애기
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		mPlayer = MediaPlayer.create(this, R.raw.mainsong);
		mPlayer.seekTo(0);
		mPlayer.start();

		//영업시작
		ImageButton btn = (ImageButton)findViewById(R.id.start);
		btn.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				mPlayer.release();
				mPlayer=null;

				ConnectivityManager manager = (ConnectivityManager) getSystemService (Context.CONNECTIVITY_SERVICE);
				boolean isMobile = manager.getNetworkInfo(ConnectivityManager.TYPE_MOBILE).isConnectedOrConnecting();
				boolean isWifi = manager.getNetworkInfo(ConnectivityManager.TYPE_WIFI).isConnectedOrConnecting();

				if((isMobile == false) && (isWifi == false)){

					mPlayer = MediaPlayer.create(TaxiApp.this, R.raw.networkerror);
					mPlayer.seekTo(0);
					mPlayer.start();

					new AlertDialog.Builder(TaxiApp.this)
					.setTitle("확인")
					.setMessage("        wifi 또는 3G 연결 후\n           실행하여 주십시오")
					.setIcon(R.drawable.information)
					.setNegativeButton("닫기", null)
					.show();
				}else{
					mPlayer = MediaPlayer.create(TaxiApp.this, R.raw.soundstarttaxi);
					mPlayer.seekTo(0);
					mPlayer.start();

					Intent in = new Intent(TaxiApp.this, Start1.class);
					startActivity(in);
				}
			}
		});
		
	}// end of onCreate()

	@Override
	protected void onDestroy() {
		super.onDestroy();
		if(mPlayer!=null){
			mPlayer.release();
			mPlayer=null;
		}
	}
	
}