package app.tama;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

public class Help extends Activity {
	ArrayList<MyItem> arItem;
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE); 

		setContentView(R.layout.widget_listtest);

		arItem = new ArrayList<MyItem>();
		MyItem mi;
		mi = new MyItem(R.drawable.start, "TAMA를 시작합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.uselist, "이용했던 내역(날짜, 택시, 차번호)를 관리합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.option, "TAMA 기능을 설정합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.homepage, "TAMA 홈페이지로 이동합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.searchstart, "현재 사용자의 위치로부터 설정한 거리 반경내의 빈차등록된 택시를 검색합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.mylocation, "현재 사용자의 위치로 이동합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.sms, "TAMA 매칭번호를 대상에게 SMS전송을 하여 인터넷으로 실시간 위치정보를 알 수 있습니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.end, "메인으로 이동합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.helpleft, "아이콘의 위치가 좌측 하단에 위치하게됩니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.helpright, "아이콘의 위치가 우측 하단에 위치하게됩니다.");arItem.add(mi);
		mi = new MyItem(0, "-옵션-");arItem.add(mi);
		mi = new MyItem(R.drawable.option1, "▷ 자동매칭\n사용자와 가장 가까운 위치의 택시를 선택하여 자동으로 매칭할 수 있게 됩니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.option1, "▷ 선택매칭\n사용자가 직접 빈차로 등록된 택시를 선택해 매칭을 합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.option1, "▷ 거리설정\n현재 사용자의 위치에서 설정한 거리의 반경만큼 택시를 검색합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.option1, "▷ 음성지원\n음성안내의 사용유무를 설정합니다.");arItem.add(mi);
		mi = new MyItem(R.drawable.option1, "▷ SMS서비스\nTAMA 매칭번호를 문자로 보낼 대상의 전화번호를 입력하여 저장합니다. 저장된 번호는 문자 전송시수신번호에 자동 기입됩니다.");arItem.add(mi);
		MyListAdapter MyAdapter = new MyListAdapter(this, R.layout.widget_icontext, arItem);

		ListView MyList;
		MyList=(ListView)findViewById(R.id.list);
		MyList.setAdapter(MyAdapter);

	}
}

//리스트 뷰에 출력할 항목
class MyItem {
	MyItem(int aIcon, String aName) {
		Icon = aIcon;
		Name = aName;
	}
	int Icon;
	String Name;
}

//어댑터 클래스
class MyListAdapter extends BaseAdapter {
	Context maincon;
	LayoutInflater Inflater;
	ArrayList<MyItem> arSrc;
	int layout;

	public MyListAdapter(Context context, int alayout, ArrayList<MyItem> aarSrc) {
		maincon = context;
		Inflater = (LayoutInflater)context.getSystemService(
				Context.LAYOUT_INFLATER_SERVICE);
		arSrc = aarSrc;
		layout = alayout;
	}

	public int getCount() {
		return arSrc.size();
	}

	public String getItem(int position) {
		return arSrc.get(position).Name;
	}

	public long getItemId(int position) {
		return position;
	}

	// 각 항목의 뷰 생성
	public View getView(int position, View convertView, ViewGroup parent) {
		if (convertView == null) {
			convertView = Inflater.inflate(layout, parent, false);
		}

		ImageView img = (ImageView)convertView.findViewById(R.id.img);
		img.setImageResource(arSrc.get(position).Icon);

		TextView txt = (TextView)convertView.findViewById(R.id.text);
		txt.setText(arSrc.get(position).Name);

		return convertView;
	}
}
