package app.tama;


import android.app.*;
import android.content.*;
import android.media.*;
import android.net.*;
import android.os.*;
import android.preference.*;
import android.util.*;
import android.view.*;
import android.widget.*;

public class Main extends Activity {

	private SharedPreferences pref;	//옵션에서 옵션값 가져오기
	private String getAutoMatching;	//옵션에서 꺼내온 자동/수동의 밸류값 ("auto" or "manual")
	private String getVoice;		//옵션에서 뽑아온 음성지원 밸류값
	private MediaPlayer mPlayer;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {

		//타이틀 없애기
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		//초기화면 버튼 리스너 설정
		findViewById(R.id.start).setOnClickListener(clickListener);
		findViewById(R.id.uselist).setOnClickListener(clickListener);
		findViewById(R.id.option).setOnClickListener(clickListener);
		findViewById(R.id.homepage).setOnClickListener(clickListener);

		mPlayer = MediaPlayer.create(this, R.raw.mainsong); 
		mPlayer.seekTo(0);
		mPlayer.start();

	}

	//리스너 설정 걸어주는 부분
	ImageButton.OnClickListener clickListener = new ImageButton.OnClickListener(){

		public void onClick(View v) {

			//스타트
			if(v.getId()==R.id.start){

				ConnectivityManager manager = (ConnectivityManager) getSystemService (Context.CONNECTIVITY_SERVICE);
				boolean isMobile = manager.getNetworkInfo(ConnectivityManager.TYPE_MOBILE).isConnectedOrConnecting();
				boolean isWifi = manager.getNetworkInfo(ConnectivityManager.TYPE_WIFI).isConnectedOrConnecting();

				
				mPlayer.release();
				mPlayer=null;

				if((isMobile == false) && (isWifi == false)){

					if(getVoice.equals("true")){
						mPlayer = MediaPlayer.create(Main.this, R.raw.networkerror);
						mPlayer.seekTo(0);
						mPlayer.start();
					}

					new AlertDialog.Builder(Main.this)
					.setTitle("확인")
					.setMessage("        wifi 또는 3G 연결 후\n           실행하여 주십시오")
					.setIcon(R.drawable.information)
					.setNegativeButton("닫기", null)
					.show();
				}
				//환경설정 중 자동/수동 의 값을 비교해서 분기
				else if(getAutoMatching.equals("auto")){
					
					if(getVoice.equals("true")){
						mPlayer = MediaPlayer.create(Main.this, R.raw.soundmatchingstart);
						mPlayer.seekTo(0);
						mPlayer.start();
					}
					
					Intent intent = new Intent(Main.this, SearchAuto.class);
					startActivity(intent);
				}else{
					
					if(getVoice.equals("true")){
						mPlayer = MediaPlayer.create(Main.this, R.raw.soundstart);
						mPlayer.seekTo(0);
						mPlayer.start();
					}
					
					Intent intent = new Intent(Main.this, SearchManual.class);
					startActivity(intent);
				}

				//이용내역
			}else if(v.getId()==R.id.uselist){ 
				Intent intent = new Intent(Main.this, UseList.class);
				startActivity(intent);
				//옵션	
			}else if(v.getId()==R.id.option){
				Intent intent = new Intent(Main.this, Option.class);
				startActivity(intent);
				//홈페이지
			}else if(v.getId()==R.id.homepage){
				Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse("http://61.106.60.79/web/main.do"));
				startActivity(intent);
			}

		}

	};

	public void onResume() {
		super.onResume();

		//옵션값을 뽑아옴
		pref = PreferenceManager.getDefaultSharedPreferences(Main.this);
		//automatching 이라는 키값에서 현재 설정된 옵션값을 뽑아옴
		getAutoMatching = pref.getString("automatching", "auto");
		getVoice = pref.getString("voice", "true");
		Log.d("111",getAutoMatching);

	};

	@Override
	protected void onDestroy() {
		super.onDestroy();
		if(mPlayer!=null){
			mPlayer.release();
			mPlayer=null;
		}
	}
}