package app.tama;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import website.company.vo.UsedInfoVO;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.DialogInterface.OnClickListener;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Geocoder;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.preference.PreferenceManager;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.Window;
import android.view.animation.AnimationUtils;
import android.widget.ViewFlipper;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

public class SearchAuto extends MapActivity {

	private List<JSONObject> emptyTaxiesFromS = new ArrayList<JSONObject>();	//서버에서 오는 빈차정보들
	private MapView mapView;													//맵뷰
	private MapController mController;											//맵컨트롤
	private MyLocation myLocation;												//내위치 클래스
	private List<Overlay> overlays = new ArrayList<Overlay>();					//지도에 표시될 overlay
	private List<OverlayItem> emptyTaxiesOnMap = new ArrayList<OverlayItem>();	//overlay에 추가될 빈차좌표들
	private Drawable car;						//지도에 표시될 택시그림
	private OverlayItem clickItem = null;		//승객이 선택한 택시overlayitem
	private TelephonyManager telManager;		//앱 설치한 폰의 번호 가져오기
	private String tel = null;					//뽑아온 전화번호
	public static ObjectOutputStream out;
	public static ObjectInputStream in;
	public static Socket socket;
	private ProgressDialog showInfoDia;			//프로그래스다이얼로그
	private Handler handler;					//핸들러

	private String myAddr = "";					//내위치 주소 지오코딩한것
	private SharedPreferences pref;				//옵션값 뽑아오는 도구
	private String getDistance;					//뽑아온 거리설정 밸류값
	private ViewFlipper mFlipper;				//상단 알림글 나타내는 도구
	private JSONArray taxi;						//서버에서 읽은 값을 jsonArray를 이용해 키, 값으로 만듬 
	private String getVoice;
	private MediaPlayer mPlayer;

	@Override
	protected boolean isRouteDisplayed() {
		return false;
	}

	@Override
	protected void onCreate(Bundle icicle) {

		//타이틀 없애기
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		super.onCreate(icicle);
		setContentView(R.layout.automap);

		//맵뷰의 기본설정(줌가능, 기본줌 17)
		mapView = (MapView)findViewById(R.id.mapview3);
		mController = mapView.getController();
		mapView.setBuiltInZoomControls(true);
		mController.setZoom(17);

		//내 위치 지도에 추가
		myLocation = new MyLocation(SearchAuto.this, mapView);
		overlays = mapView.getOverlays();
		overlays.add(myLocation);

		//상단 알림글 불러오고 움직임 세팅, 스타트 걸어주기
		mFlipper = (ViewFlipper) findViewById(R.id.flipper3);
		mFlipper.setInAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_in));
		mFlipper.setOutAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_out));
		mFlipper.startFlipping();

		//내전화번호 얻기
		telManager = (TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);
		tel = telManager.getLine1Number();
		System.out.println("telephone:"+tel);

		//핸들러
		handler = new Handler(){

			@Override
			public void handleMessage(Message msg) {

				//주위에 택시가 없을 경우
				if(msg.what==0){
					if(getVoice.equals("true")){

						mPlayer = MediaPlayer.create(SearchAuto.this, R.raw.soundnotaxi);
						mPlayer.seekTo(0);
						mPlayer.start();
					}

					Builder failDia = new AlertDialog.Builder(SearchAuto.this);
					failDia.setMessage("주변에 빈 택시가 없습니다.");
					failDia.setTitle("빈차찾기 실패");
					failDia.setPositiveButton("OK", new OnClickListener() {

						public void onClick(DialogInterface dialog, int which) {

							finish();
							try {
								SearchAuto.in.close();
								SearchAuto.out.close();
								SearchAuto.socket.close();
							} catch (IOException e) {
								e.printStackTrace();
							}
						}
					});
					failDia.show();
				}

				//택시 찾기 성공
				else if(msg.what == 1){

					if(getVoice.equals("true")){

						mPlayer = MediaPlayer.create(SearchAuto.this, R.raw.soundfindtaxiwait);
						mPlayer.seekTo(0);
						mPlayer.start();
					}

					System.out.println("handler in**********************1");
					showInfoDia = new ProgressDialog(SearchAuto.this);
					showInfoDia.setMessage("빈 택시를 찾았습니다.\n잠시만 기다려 주십시오...");
					showInfoDia.setTitle("택시찾기");
					showInfoDia.setCancelable(false);
					showInfoDia.show();
					try {
						parseEmptyTaxiGeoes(taxi);
					} catch (JSONException e) {
						e.printStackTrace();
					}

				}
			}

		};


		myLocation.runOnFirstFix(new Runnable(){

			public void run() {
				mController.animateTo(myLocation.getMyLocation());
				TCPClient tpClient = new TCPClient(myLocation.getMyLocation().getLatitudeE6(),
						myLocation.getMyLocation().getLongitudeE6(),
						tel,
						getDistance);

				tpClient.run();

			}

		});

		pref = PreferenceManager.getDefaultSharedPreferences(this);
		getDistance = pref.getString("distance", "1");
		getVoice = pref.getString("voice", "true");

	}// end of onCreate()


	//나의 현재 위치 얻는 클래스
	private class MyLocation extends MyLocationOverlay{

		public MyLocation(Context context, MapView mapView) {
			super(context, mapView);
		}

	}

	
	//빈 택시 오버레이클래스
	private class EmptyTaxiOverlays extends ItemizedOverlay<OverlayItem>{

		private List<Address> addr;
		String myAddr;

		public EmptyTaxiOverlays(Drawable arg0) {
			super(arg0);
			boundCenterBottom(arg0);
			//createItem이 작동하게함
			populate();		
		}

		@Override
		protected OverlayItem createItem(int i) {

			return emptyTaxiesOnMap.get(i);
		}

		//size만큼 createItem실행
		@Override
		public int size() {
			return emptyTaxiesOnMap.size();
		}

	}
	

	//서버와 통신할 client클래스. 빈차찾기
	private class TCPClient implements Runnable{

		private static final String serverIP = "61.106.60.79";
		private static final int serverPort = 8888;
		private StringBuffer msg = new StringBuffer();
		private UsedInfoVO vo = new UsedInfoVO();

		public TCPClient(int latitude, int longitude, String tel, String distance){

			this.vo.setLatitude(latitude+"");
			this.vo.setLongitude(longitude+"");
			this.vo.setUsedInfoPhone(tel);
			this.vo.setMsg("autoTaxi");
			this.vo.setDistance(Double.parseDouble(distance));
		}

		public void run() {
			try{
				InetAddress serverAddr = InetAddress.getByName(serverIP);

				socket = new Socket(serverAddr.getHostAddress(), serverPort);

				try{

					//data보냄
					out = new ObjectOutputStream(socket.getOutputStream());
					in = new ObjectInputStream(socket.getInputStream());
					out.writeObject(vo);
					out.flush();

					Looper.prepare();
					String emptyTaxiGeoes = in.readUTF();					

					if(emptyTaxiGeoes.equals("fail")){
						handler.sendEmptyMessage(0);
					}


					taxi = new JSONArray(emptyTaxiGeoes);
					System.out.println(taxi.toString());

					handler.sendEmptyMessage(1);

					int a = 0;
					while(true){
						if(a>2){
							showInfoDia.dismiss();	
							break;
						}
						try {
							Thread.sleep(1000);
							a++;

						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}

					//자동매칭일때 다음 액티비티로 전환할 것.
					Intent intent = new Intent(SearchAuto.this, SuccessMatching.class);
					intent.putExtra("SelectedTaxi", emptyTaxiesFromS.get(0).getString("usedInfoCarNum"));
					intent.putExtra("myLatitude", myLocation.getMyLocation().getLatitudeE6()+"");
					intent.putExtra("myLongitude", myLocation.getMyLocation().getLongitudeE6()+"");
					intent.putExtra("tel", tel);
					intent.putExtra("addr", myAddr);

					startActivity(intent);
					finish();

					Looper.loop();
				}catch(Exception e){
					Log.e("TCP", "C: Error1");
				}

			}catch(Exception e){
				Log.e("TCP", "Client: Error2");

			}
		}

	}

	//통신에서 가져온 빈차정보들 파싱
	public void parseEmptyTaxiGeoes(JSONArray emptyTaxiGeoes) throws JSONException{

		//'위도:경도:차번호^위도:경도:차번호^' 이렇게 전송됨.
		Log.d("D", emptyTaxiGeoes.toString());		

		for(int i =0; i<emptyTaxiGeoes.length(); i++){
			emptyTaxiesFromS.add(emptyTaxiGeoes.getJSONObject(i));
		}

		//택시 좌표 지도에 표시하기
		inputTaxi();

	}

	//택시 좌표 지도에 표시하기
	public void inputTaxi() throws JSONException{
		List<Address> addr;

		//emptyTaxies에 빈택시 좌표 넣기
		for(int i=0; i<emptyTaxiesFromS.size(); i++){
			emptyTaxiesOnMap.add(new OverlayItem(new GeoPoint(emptyTaxiesFromS.get(i).getInt("latitude"), emptyTaxiesFromS.get(i).getInt("longitude")),
					"빈차"+(i+1), emptyTaxiesFromS.get(i).getString("usedInfoCarNum")));
		}

		//지도에 빈차위치 표시
		car = getResources().getDrawable(R.drawable.taxi);
		EmptyTaxiOverlays eptTaxies = new EmptyTaxiOverlays(car);
		overlays.add(eptTaxies);
		mapView.invalidate();


		//내 좌표로 주소변환
		Geocoder coder = new Geocoder(SearchAuto.this, Locale.KOREAN);
		try {
			addr = coder.getFromLocation(myLocation.getMyLocation().getLatitudeE6()/1000000.0, myLocation.getMyLocation().getLongitudeE6()/1000000.0, 1);
			myAddr = addr.get(0).getAddressLine(0);
			System.out.println(myAddr);

		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	@Override
	protected void onPause() {
		super.onPause();
		myLocation.disableCompass();
		myLocation.disableMyLocation();

	}

	@Override
	protected void onResume() {
		super.onResume();
		myLocation.enableCompass();
		myLocation.enableMyLocation();

	}

}
