package app.tama;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import website.company.vo.UsedInfoVO;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.DialogInterface.OnClickListener;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Geocoder;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.animation.AnimationUtils;
import android.widget.ImageButton;
import android.widget.Toast;
import android.widget.ViewFlipper;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

public class SearchManual extends MapActivity {

	private List<JSONObject> emptyTaxiesFromS = new ArrayList<JSONObject>();	//서버에서 오는 빈차정보들
	private MapView mapView;													//맵뷰
	private MapController mController;											//맵컨트롤
	private MyLocation myLocation;												//내위치 클래스
	private List<Overlay> overlays = new ArrayList<Overlay>();					//지도에 표시될 overlay
	private List<OverlayItem> emptyTaxiesOnMap = new ArrayList<OverlayItem>();	//overlay에 추가될 빈차좌표들
	private Drawable car;						//지도에 표시될 택시그림
	private OverlayItem clickItem = null;		//승객이 선택한 택시overlayitem
	private TelephonyManager telManager;		//앱 설치한 폰의 번호 가져오기
	private String tel = null;					//뽑아온 전화번호
	public static ObjectOutputStream out;
	public static ObjectInputStream in;
	public static Socket socket;				//스태틱 소켓(매칭됐을때도 이 소켓을 씀)
	Builder failDia;							//다이얼로그 빌더

	private ImageButton goMyLocation;			//내위치가기 버튼
	private ImageButton goMyLocationLeft;		//내위치가기 왼쪽 버튼
	private ImageButton searchStart;			//빈차찾기 버튼
	private ImageButton searchStartLeft;		//빈차찾기 왼쪽 버튼
	private boolean clickSearch = false;		//빈차를 한번 찾았는지 여부 확인
	private SharedPreferences pref;				//옵션값 뽑아오는 도구
	private String getDistance;					//뽑아온 거리설정 밸류값
	private String getUi;						//뽑아온 버튼 초기 위치 밸류값
	private String getVoice;					//뽑아온 음성지원 밸류값
	private ViewFlipper mFlipper;				//상단 알림글 나타내는 도구
	private MediaPlayer mPlayer;

	//맵액티비티를 상속하면 꼭 해줘야하는 메소드
	@Override
	protected boolean isRouteDisplayed() {

		return false;
	}

	@Override
	protected void onCreate(Bundle icicle) {

		//타이틀 없애기
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		super.onCreate(icicle);
		setContentView(R.layout.startmap);

		//맵뷰의 기본설정(줌가능, 기본줌 17)
		mapView = (MapView)findViewById(R.id.mapview);
		mController = mapView.getController();
		mapView.setBuiltInZoomControls(true);
		mController.setZoom(17);

		//내 위치 지도에 추가
		myLocation = new MyLocation(SearchManual.this, mapView);
		overlays = mapView.getOverlays();
		overlays.add(myLocation);

		//버튼 불러오기
		goMyLocation = (ImageButton) findViewById(R.id.myLocation);
		goMyLocationLeft = (ImageButton) findViewById(R.id.myLocationLeft);
		searchStart = (ImageButton)findViewById(R.id.searchStart);
		searchStartLeft = (ImageButton) findViewById(R.id.searchStartLeft);

		//상단 알림글 불러오고 움직임 세팅, 스타트 걸어주기
		mFlipper = (ViewFlipper) findViewById(R.id.flipper);
		mFlipper.setInAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_in));
		mFlipper.setOutAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_out));
		mFlipper.startFlipping();

		//내전화번호 얻기
		telManager = (TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);
		tel = telManager.getLine1Number();
		System.out.println("telephone:"+tel);

		//오른쪽 서치스타트 버튼
		searchStart.setOnClickListener(new ImageButton.OnClickListener(){

			public void onClick(View v) {

				if(getVoice.equals("true")){
					if(mPlayer!=null){
						mPlayer.release();
						mPlayer=null;
					}
					mPlayer = MediaPlayer.create(SearchManual.this, R.raw.soundsearchtaxi);
					mPlayer.seekTo(0);
					mPlayer.start();
				}

				clickSearch = true;
				//서버에서 빈차좌표 가져와서 뿌려주기. 서버로 보낼 데이터: 승객좌표, 전화번호, 옵션에서 가져온 매칭거리
				TCPClient tpClient = new TCPClient(myLocation.getMyLocation().getLatitudeE6(),
						myLocation.getMyLocation().getLongitudeE6(),
						tel,
						getDistance);

				tpClient.run();

				//한번 서치후 서치버튼 사라짐(악의적인 유저 방지)
				searchStart.setVisibility(View.INVISIBLE);

			}

		});

		//왼쪽 서치 스타트 버튼
		searchStartLeft.setOnClickListener(new ImageButton.OnClickListener(){

			public void onClick(View v) {

				if(getVoice.equals("true")){
					if(mPlayer!=null){
						mPlayer.release();
						mPlayer=null;
					}
					mPlayer = MediaPlayer.create(SearchManual.this, R.raw.soundsearchtaxi);
					mPlayer.seekTo(0);
					mPlayer.start();
				}

				clickSearch = true;
				//서버에서 빈차좌표 가져와서 뿌려주기. 서버로 보낼 데이터: 승객좌표, 전화번호, 옵션에서 가져온 매칭거리
				TCPClient tpClient = new TCPClient(myLocation.getMyLocation().getLatitudeE6(),
						myLocation.getMyLocation().getLongitudeE6(),
						tel,
						getDistance);

				tpClient.run();

				//한번 서치후 왼쪽서치버튼 사라짐
				searchStartLeft.setVisibility(View.INVISIBLE);

			}

		});

		//내위치 가기 버튼
		goMyLocation.setOnClickListener(new ImageButton.OnClickListener(){

			public void onClick(View arg0) {

				if(getVoice.equals("true")){
					if(mPlayer!=null){
						mPlayer.release();
						mPlayer=null;
					}
					mPlayer = MediaPlayer.create(SearchManual.this, R.raw.soundmylocation);
					mPlayer.seekTo(0);
					mPlayer.start();
				}

				//토스트 띄어준 후~
				Toast.makeText(SearchManual.this, "현재 위치로 이동합니다", Toast.LENGTH_SHORT).show();
				//내위치로 스르륵~ 이동
				mapView.getController().animateTo(myLocation.getMyLocation());

			}

		});

		//내위치 가기 왼쪽버튼
		goMyLocationLeft.setOnClickListener(new ImageButton.OnClickListener(){

			public void onClick(View v) {

				if(getVoice.equals("true")){
					mPlayer = MediaPlayer.create(SearchManual.this, R.raw.soundmylocation);
					mPlayer.seekTo(0);
					mPlayer.start();
				}

				Toast.makeText(SearchManual.this, "현재 위치로 이동합니다", Toast.LENGTH_SHORT).show();
				mapView.getController().animateTo(myLocation.getMyLocation());
			}

		});

		//처음 위치가 조사될 때 실행되는 러너블
		myLocation.runOnFirstFix(new Runnable(){

			public void run() {

				mController.animateTo(myLocation.getMyLocation());

			}

		});
	}

	//나의 현재 위치 얻는 클래스
	private class MyLocation extends MyLocationOverlay{

		public MyLocation(Context context, MapView mapView) {
			super(context, mapView);
		}

		//내위치 아이콘 터치했을 때 실행
		@Override
		protected boolean dispatchTap() {
			Toast.makeText(SearchManual.this, "현재 위치입니다.", Toast.LENGTH_SHORT).show();
			return false;
		}		

	}

	//빈 택시 오버레이클래스
	private class EmptyTaxiOverlays extends ItemizedOverlay<OverlayItem>{

		private List<Address> addr;
		String myAddr;

		public EmptyTaxiOverlays(Drawable arg0) {
			super(arg0);
			//아이템의 그림자
			boundCenterBottom(arg0);

			//createItem이 작동하게함
			populate();		
		}

		@Override
		protected OverlayItem createItem(int i) {

			return emptyTaxiesOnMap.get(i);
		}

		//size만큼 createItem실행
		@Override
		public int size() {

			return emptyTaxiesOnMap.size();
		}


		//매칭여부 물어보는 다이얼로그창. 자동매칭시 택시의 번호와 위치만 보이게됨. 버튼은 추가안함.
		@Override
		protected boolean onTap(int index) {

			clickItem = emptyTaxiesOnMap.get(index);

			//내 좌표로 주소변환
			Geocoder coder = new Geocoder(SearchManual.this, Locale.KOREAN);
			try {
				System.out.println(coder.toString());
				addr = coder.getFromLocation(myLocation.getMyLocation().getLatitudeE6()/1000000.0, myLocation.getMyLocation().getLongitudeE6()/1000000.0, 1);
				System.out.println(addr);
				myAddr = addr.get(0).getAddressLine(0);
				System.out.println(myAddr);

			} catch (Exception e) {
				e.printStackTrace();
			}

			String carNum = clickItem.getSnippet();

			if(getVoice.equals("true")){
				mPlayer.release();
				mPlayer=null;
				mPlayer = MediaPlayer.create(SearchManual.this, R.raw.soundbeforematching);
				mPlayer.seekTo(0);
				mPlayer.start();
			}

			//매칭확인 다이얼로그 생성
			Builder dia = new AlertDialog.Builder(SearchManual.this);
			dia.setTitle("매칭확인");
			dia.setMessage(carNum+"와 매칭하시겠습니까?");
			dia.setPositiveButton("Yes", new OnClickListener(){

				//"Yes"클릭시 내 정보 인텐트에 담아서 다음 화면으로 넘김. 

				public void onClick(DialogInterface arg0, int arg1) {
					Intent intent = new Intent(SearchManual.this, SuccessMatching.class);
					intent.putExtra("SelectedTaxi", clickItem.getSnippet());						//택시번호
					intent.putExtra("myLatitude", myLocation.getMyLocation().getLatitudeE6()+"");	//내위치 위도
					intent.putExtra("myLongitude", myLocation.getMyLocation().getLongitudeE6()+"");	//내위치 경도
					intent.putExtra("tel", tel);													//내 전화번호
					intent.putExtra("addr", myAddr);												//내 위치 지오코딩한것

					startActivity(intent);
					finish();

				}

			});
			dia.setNegativeButton("No", null);
			dia.show();

			return false;
		}


	}


	//서버와 통신할 client클래스. 빈차찾기
	private class TCPClient implements Runnable{

		private static final String serverIP = "61.106.60.79";		//아이피
		private static final int serverPort = 8888;						//포트번호
		private StringBuffer msg = new StringBuffer();
		private UsedInfoVO vo = new UsedInfoVO();

		public TCPClient(int latitude, int longitude, String tel, String distance){

			this.vo.setLatitude(latitude+"");
			this.vo.setLongitude(longitude+"");
			this.vo.setUsedInfoPhone(tel);
			this.vo.setMsg("findTaxi");
			this.vo.setDistance(Double.parseDouble(distance));
		}


		public void run() {

			try{
				InetAddress serverAddr = InetAddress.getByName(serverIP);


				socket = new Socket(serverAddr.getHostAddress(), serverPort);

				try{

					//data보냄
					out = new ObjectOutputStream(socket.getOutputStream());
					in = new ObjectInputStream(socket.getInputStream());
					out.writeObject(vo);
					out.flush();

					String emptyTaxiGeoes = in.readUTF();					

					//빈차 없을때 다이얼로그 띄움
					if(emptyTaxiGeoes.equals("fail")){

						if(getVoice.equals("true")){

							mPlayer.release();
							mPlayer=null;

							mPlayer = MediaPlayer.create(SearchManual.this, R.raw.soundnotaxi);
							mPlayer.seekTo(0);
							mPlayer.start();
						}

						failDia = new AlertDialog.Builder(SearchManual.this);
						failDia.setMessage("주변에 빈 택시가 없습니다.");
						failDia.setTitle("빈차찾기 실패");
						failDia.setPositiveButton("OK", new OnClickListener() {

							public void onClick(DialogInterface dialog, int which) {

								finish();

								try {
									SearchManual.in.close();
									SearchManual.out.close();
									SearchManual.socket.close();
								} catch (IOException e) {
									e.printStackTrace();
								}
							}
						});
						failDia.show();
					}		
					JSONArray taxi = new JSONArray(emptyTaxiGeoes);

					//택시좌표 파싱
					parseEmptyTaxiGeoes(taxi);

				}catch(Exception e){
					Log.e("TCP", "C: Error1");
				}

			}catch(Exception e){
				Log.e("TCP", "Client: Error2");

			}
		}

	}

	//통신에서 가져온 빈차정보들 파싱
	public void parseEmptyTaxiGeoes(JSONArray emptyTaxiGeoes) throws JSONException{

		//'위도:경도:차번호^위도:경도:차번호^' 이렇게 전송됨.
		Log.d("D", emptyTaxiGeoes.toString());		

		for(int i =0; i<emptyTaxiGeoes.length(); i++){
			emptyTaxiesFromS.add(emptyTaxiGeoes.getJSONObject(i));
		}

		//택시 좌표 지도에 표시하기
		inputTaxi();

	}

	//택시 좌표 지도에 표시하기
	public void inputTaxi() throws JSONException{

		System.out.println("EmptyTaxiSize:"+emptyTaxiesFromS.size());

		//emptyTaxies에 빈택시 좌표 넣기
		for(int i=0; i<emptyTaxiesFromS.size(); i++){
			emptyTaxiesOnMap.add(new OverlayItem(new GeoPoint(emptyTaxiesFromS.get(i).getInt("latitude"), emptyTaxiesFromS.get(i).getInt("longitude")),
					"빈차"+(i+1), emptyTaxiesFromS.get(i).getString("usedInfoCarNum")));
		}


		//지도에 빈차위치 표시
		car = getResources().getDrawable(R.drawable.taxi);
		EmptyTaxiOverlays eptTaxies = new EmptyTaxiOverlays(car);
		overlays.add(eptTaxies);
		mapView.invalidate();


	}

	//포즈
	@Override
	protected void onPause() {
		super.onPause();
		myLocation.disableCompass();
		myLocation.disableMyLocation();

	}

	//리줌
	@Override
	protected void onResume() {
		super.onResume();
		myLocation.enableCompass();
		myLocation.enableMyLocation();

		//옵션값에서 거리설정, 버튼위치 밸류값 뽑아옴
		pref = PreferenceManager.getDefaultSharedPreferences(this);
		getDistance = pref.getString("distance", "1");
		getVoice = pref.getString("voice", "true");
		getUi = pref.getString("ui", "right");

		if(getUi.equals("left")){
			goMyLocation.setVisibility(View.INVISIBLE);
			goMyLocationLeft.setVisibility(View.VISIBLE);
			searchStart.setVisibility(View.INVISIBLE);
			searchStartLeft.setVisibility(View.VISIBLE);
		}

	}

	//메뉴 만들기
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		super.onCreateOptionsMenu(menu);

		menu.add(0, 1, 0, "왼손잡이").setIcon(R.drawable.left);
		menu.add(0, 2, 0, "도움말").setIcon(R.drawable.information);
		menu.add(0, 3, 0, "오른손잡이").setIcon(R.drawable.right);
		return true;
	}

	//메뉴를 선택했을시
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		//옵션값을 다시 저장하기 위한 도구
		SharedPreferences.Editor edit = pref.edit();

		switch(item.getItemId()){

		//옵션값을 바꾸고 커밋 후 버튼위치 바꾸기
		case 1:
			edit.putString("ui", "left");
			edit.commit();
			goMyLocation.setVisibility(View.INVISIBLE);
			goMyLocationLeft.setVisibility(View.VISIBLE);

			//서치 실행을 하지 않았을 때 위치 변환
			if(clickSearch==false){
				searchStart.setVisibility(View.INVISIBLE);
				searchStartLeft.setVisibility(View.VISIBLE);
			}
			return true;
		case 2:
			Intent intent = new Intent(SearchManual.this, Help.class);
			startActivity(intent);
			return true;
		case 3:
			edit.putString("ui", "right");
			edit.commit();
			goMyLocation.setVisibility(View.VISIBLE);
			goMyLocationLeft.setVisibility(View.INVISIBLE);
			if(clickSearch==false){
				searchStart.setVisibility(View.VISIBLE);
				searchStartLeft.setVisibility(View.INVISIBLE);
			}
			return true;

		}

		return false;
	}

}
