package app.tama;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import website.company.vo.UsedInfoVO;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.DialogInterface.OnClickListener;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Geocoder;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.preference.PreferenceManager;
import android.telephony.SmsManager;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.animation.AnimationUtils;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.Toast;
import android.widget.ViewFlipper;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

public class SuccessMatching extends MapActivity {

	private ProgressDialog dia;		//택시기사의 응답을 기다리는 다이얼로그
	private Builder matchFailDia;	//매칭실패 다이얼로그
	private UsedInfoVO vo;			//이용정보
	private ObjectOutputStream out;
	private ObjectInputStream in;
	private Handler handler,handler2;
	private List<Overlay> overlays = new ArrayList<Overlay>();					//지도에 표시될 overlay
	private List<OverlayItem> matchedTaxiGeo = new ArrayList<OverlayItem>();	//overlay에 추가될 빈차좌표들
	private MapView matchedMap;					//맵뷰
	private MapController mapController;		//맵컨트롤
	private Toast myLocaToast, taxiToast;		//토스트
	private MatchedTaxiOverlays matchedTaxi;	//매칭된 택시 오버레이
	private Drawable taxi;						//지도에 표시될 택시그림
	private MyLocation myLocation;				//내위치 클래스
	private String taxiNum = "";				//매칭된 택시번호
	private boolean isAction = true;			//맵에 처음 애드 됐는지 여부확인
	String matchingNumStr="";					//매칭번호 ( 중요!! 매칭번호 앞에 : 붙어서옴, ex) :1234555)


	private EditText smsText;						//sms 다이얼로그의 sms 부분
	private EditText matchingNum;					//sms 다이얼로그의 매칭번호 부분
	private String getSms;							//옵션에서 뽑아온 sms 보낼 전화번호
	private String getUi;							//옵션에서 뽑아온 버튼위치 설정
	private String getMatch="";						//옵션에서 뽑아온 자동/수동 설정
	private SharedPreferences pref;					//옵션에서 뽑아오는 도구
	private String matchingTaxiData = "";			//택시좌표
	private ViewFlipper mFlipper;					//상단 알림글 나타내는 도구
	private String getVoice;
	private MediaPlayer mPlayer;

	private DBHelper mHelper;
	private List<Address> addr;
	private StringBuffer myAddr;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		//타이틀 없애기
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		super.onCreate(savedInstanceState);
		setContentView(R.layout.matchingmap);

		//맵뷰의 기본설정(줌가능, 기본줌 17)
		matchedMap = (MapView)findViewById(R.id.mapview2);
		mapController = matchedMap.getController();
		mapController.setZoom(17);
		matchedMap.setBuiltInZoomControls(true);

		//내 위치 지도에 추가
		overlays = matchedMap.getOverlays();
		myLocation = new MyLocation(SuccessMatching.this, matchedMap);
		overlays.add(myLocation);

		//버튼 불러오기
		findViewById(R.id.sms).setOnClickListener(mClickListener);
		findViewById(R.id.end).setOnClickListener(mClickListener);
		findViewById(R.id.myLocation).setOnClickListener(mClickListener);
		findViewById(R.id.smsLeft).setOnClickListener(mClickListener);
		findViewById(R.id.endLeft).setOnClickListener(mClickListener);
		findViewById(R.id.myLocationLeft).setOnClickListener(mClickListener);

		//상단 알림글 불러오고 움직임 세팅, 스타트 걸어주기
		mFlipper = (ViewFlipper) findViewById(R.id.flipper2);
		mFlipper.setInAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_in));
		mFlipper.setOutAnimation(AnimationUtils.loadAnimation(this, R.anim.push_left_out));
		mFlipper.startFlipping();

		//처음 위치가 조사될 때 실행되는 러너블
		myLocation.runOnFirstFix(new Runnable() {

			public void run() {

				mapController.animateTo(myLocation.getMyLocation());
			}
		});

		//매치 되기전 액티비티에서 보내온 정보 받아 들이기( 승객전화번호, 좌표, 차번호, 주소)
		Intent intent = getIntent();
		vo = new UsedInfoVO();

		taxiNum = intent.getStringExtra("SelectedTaxi");
		vo.setLatitude(intent.getStringExtra("myLatitude"));
		vo.setLongitude(intent.getStringExtra("myLongitude"));
		vo.setUsedInfoPhone(intent.getStringExtra("tel"));
		vo.setUsedInfoCarNum(taxiNum);
		vo.setUsedInfoStartZone(intent.getStringExtra("addr"));

		//핸들러
		handler = new Handler(){

			@Override
			public void handleMessage(Message msg) {

				//응답을 기다리는 중
				if(msg.what == 0){

					if(getVoice.equals("true")){
						mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.soundwaitanswer);
						mPlayer.seekTo(0);
						mPlayer.start();
					}

					dia = new ProgressDialog(SuccessMatching.this);
					dia.setMessage("기사의 응답을 기다리는 중입니다.\n(10초 후 자동 취소)");
					dia.setCancelable(false);
					dia.show();	
				}

				//기사가 NO를 눌렀을 시
				else if(msg.what == 1){

					dia.dismiss();

					if(getVoice.equals("true")){
						mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.soundfailmatching);
						mPlayer.seekTo(0);
						mPlayer.start();
					}

					matchFailDia = 	new AlertDialog.Builder(SuccessMatching.this);
					matchFailDia.setTitle("매칭실패");
					matchFailDia.setMessage("       기사분의 용무로 인해\n       매칭에 실패하였습니다");
					matchFailDia.setPositiveButton("OK", new OnClickListener() {

						public void onClick(DialogInterface dialog, int which) {

							finish();
						}
					});
					matchFailDia.show();

				}
				//매칭 성공
				else if(msg.what == 2){
					parseMatchedTaxiGeoes(matchingTaxiData);

				}
			}
		};

		//옵션 뽑아오기
		pref = PreferenceManager.getDefaultSharedPreferences(this);

		//미리 저장한 sms번호, 버튼위치 뽑아오기
		getSms = pref.getString("smsnumber", "");
		getUi = pref.getString("ui", "right");
		getMatch = pref.getString("automatching", "");
		getVoice = pref.getString("voice", "true");


		if(getUi.equals("left")){
			findViewById(R.id.myLocation).setVisibility(View.INVISIBLE);
			findViewById(R.id.myLocationLeft).setVisibility(View.VISIBLE);
			findViewById(R.id.sms).setVisibility(View.INVISIBLE);
			findViewById(R.id.smsLeft).setVisibility(View.VISIBLE);
			findViewById(R.id.end).setVisibility(View.INVISIBLE);
			findViewById(R.id.endLeft).setVisibility(View.VISIBLE);
		}


		TCPClient client = new TCPClient(vo);
		Thread th = new Thread(client);
		th.start();
	}

	//버튼에 리스너 걸기
	ImageButton.OnClickListener mClickListener = new View.OnClickListener(){

		public void onClick(View v) {
			Intent intent;

			//sms 보내기
			if((v.getId()==R.id.sms) || (v.getId()==R.id.smsLeft)){

				final LinearLayout linear = (LinearLayout) View.inflate(SuccessMatching.this, R.layout.sms, null);

				smsText = (EditText) linear.findViewById(R.id.smstext);
				matchingNum = (EditText) linear.findViewById(R.id.matchingnumber);

				smsText.setText(getSms);
				matchingNum.setText("http://61.106.60.79/web/map.do 에서 위치확인 가능 -매칭번호"+matchingNumStr);

				if(getVoice.equals("true")){

					mPlayer.release();
					mPlayer=null;
					mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.soundsmsstart);
					mPlayer.seekTo(0);
					mPlayer.start();
				}

				new AlertDialog.Builder(SuccessMatching.this)
				.setTitle("SMS 보내기")
				.setIcon(R.drawable.smsicon)
				.setView(linear)
				.setPositiveButton("보내기", new DialogInterface.OnClickListener() {

					public void onClick(DialogInterface dialog, int which) {
						String phoneNo = smsText.getText().toString();
						String message = matchingNum.getText().toString();                 
						if (phoneNo.length()>0 && message.length()>0){ 

							if(getVoice.equals("true")){

								mPlayer.release();
								mPlayer=null;
								mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.soundsmsend);
								mPlayer.seekTo(0);
								mPlayer.start();
							}

							sendSMS(phoneNo, message);
							Toast.makeText(SuccessMatching.this, "sms 전송", Toast.LENGTH_SHORT).show();



						}
						else{

							if(getVoice.equals("true")){

								mPlayer.release();
								mPlayer=null;

								mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.soundsmsrequired);
								mPlayer.seekTo(0);
								mPlayer.start();
							}
							Toast.makeText(getBaseContext(), 
									"SMS 전송 번호를 입력하세요", 
									Toast.LENGTH_SHORT).show();


						}

					}
				})
				.setNegativeButton("취소",null)
				.show();

				//종료버튼
			}else if((v.getId()==R.id.end) || (v.getId()==R.id.endLeft)){

				if(getVoice.equals("true")){
					mPlayer.release();
					mPlayer=null;
					mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.soundrealend);
					mPlayer.seekTo(0);
					mPlayer.start();
				}

				new AlertDialog.Builder(SuccessMatching.this)
				.setTitle("확인")
				.setIcon(R.drawable.endicon)
				.setMessage("정말 종료하시겠습니까?")
				.setPositiveButton("예", mClick)
				.setNegativeButton("아니오", null)
				.show();

				//내위치 이동
			}else if((v.getId()==R.id.myLocation) || v.getId()==R.id.myLocationLeft){

				if(getVoice.equals("true")){
					mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.soundmylocation);
					mPlayer.seekTo(0);
					mPlayer.start();
				}

				Toast.makeText(SuccessMatching.this, "현재 위치로 이동합니다", Toast.LENGTH_SHORT).show();
				mapController.animateTo(myLocation.getMyLocation());
			}

		}

	};

	//sms 보내는 메소드
	private void sendSMS(String phoneNumber, String message){ 

		SmsManager sms = SmsManager.getDefault();
		sms.sendTextMessage(phoneNumber, null, message, null, null);        
	}

	//종료 눌렀을시 피니쉬
	DialogInterface.OnClickListener mClick = new DialogInterface.OnClickListener() {

		public void onClick(DialogInterface dialog, int which) {

			if(getVoice.equals("true")){

				mPlayer.release();
				mPlayer=null;

				mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.soundbyebye);
				mPlayer.seekTo(0);
				mPlayer.start();
			}

			finish();

		}
	};

	//내 위치찾기
	public class MyLocation extends MyLocationOverlay{

		public MyLocation(Context context, MapView mapView) {
			super(context, mapView);
		}

	}

	@Override
	protected boolean isRouteDisplayed() {
		return false;
	}

	//서버와 통신할 client클래스
	private class TCPClient implements Runnable{

		private UsedInfoVO vo = new UsedInfoVO();

		public TCPClient(UsedInfoVO vo){

			vo.setMsg("matching");
			this.vo = vo;
		}

		public void run() {

			//수동일때
			if(getMatch == "manual" || getMatch.equals("manual")){

				try{

					try{			

						System.out.println(SearchManual.out);
						SearchManual.out.writeObject(vo);
						SearchManual.out.reset();
						SearchManual.out.flush();

						Looper.prepare();
						String emptyTaxiGeoes = SearchManual.in.readUTF();

						//택시의 응답을 기다림
						if(emptyTaxiGeoes.equals("wait") || emptyTaxiGeoes == "wait"){

							//응답을 기다리는 핸들러 호출
							handler.sendEmptyMessage(0);
						}	
						System.out.println("************wait******************");

						matchingNumStr = SearchManual.in.readUTF();					

						System.out.println("MatchingNum:"+ matchingNumStr);

						//:로 시작하는 호출번호가 왔을 시 다이얼로그 해제
						if(matchingNumStr.startsWith(":")){
							dia.dismiss();
						}			

						//기사의 거부시 실패 다이얼로그 호출
						else if(matchingNumStr.equals("fail") || matchingNumStr == "fail"){
							handler.sendEmptyMessage(1);
						}

						//	ㅡㅡㅡㅡㅡ		자신의 위치 위도경도를 주소로 변환		ㅡㅡㅡㅡㅡ
						Geocoder coder = new Geocoder(SuccessMatching.this, Locale.KOREAN);

						try {
							addr = coder.getFromLocation(myLocation.getMyLocation().getLatitudeE6()/1000000.0, myLocation.getMyLocation().getLongitudeE6()/1000000.0, 1);
						} catch (IOException e) {
							e.printStackTrace();
						}

						myAddr = new StringBuffer(addr.get(0).getLocality()+" ");	//서울특별시
						myAddr.append(addr.get(0).getThoroughfare()+" ");			//서초2동
						myAddr.append(addr.get(0).getFeatureName());				//1333-3
						// myAddr == "서울특별시 서초동 1333-3"
						//	ㅡㅡㅡㅡㅡ		자신의 위치 위도경도를 주소로 변환		ㅡㅡㅡㅡㅡ


						//		ㅡㅡㅡㅡㅡ 		SQLite (insert) 		ㅡㅡㅡㅡㅡ
						mHelper = new DBHelper(SuccessMatching.this);

						Date now = new Date(System.currentTimeMillis());
						SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd[hh:mm]");

						SQLiteDatabase db;
						db = mHelper.getWritableDatabase();

						db.execSQL("INSERT INTO usedInfo VALUES ('"+sdf.format(now)+"', '"+myAddr+"', '"+vo.getUsedInfoCarNum()+"');");

						mHelper.close();
						//    	ㅡㅡㅡㅡㅡ 		SQLite (insert) 		ㅡㅡㅡㅡㅡ

						if(getVoice.equals("true")){

							mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.successmatching);
							mPlayer.seekTo(0);
							mPlayer.start();
						}

						try {
							while(true){
								matchingTaxiData = SearchManual.in.readUTF();
								System.out.println(matchingTaxiData);
								//오고있는 택시 좌표에 표시
								handler.sendEmptyMessage(2);
							}
						} catch (IOException e) {
							e.printStackTrace();
						}						

						Looper.loop();

					}catch(Exception e){ 
						e.printStackTrace();
						Log.e("TCP", "C: Error1");
					}

				}catch(Exception e){
					Log.e("TCP", "Client: Error2");

				}
			}

			//자동일때
			else if(getMatch == "auto" || getMatch.equals("auto")){
				try{

					try{			

						SearchAuto.out.writeObject(vo);
						SearchAuto.out.reset();
						SearchAuto.out.flush();

						Looper.prepare();
						String emptyTaxiGeoes = SearchAuto.in.readUTF();

						if(emptyTaxiGeoes.equals("wait") || emptyTaxiGeoes == "wait"){

							handler.sendEmptyMessage(0);
						}	
						System.out.println("************wait******************");

						matchingNumStr = SearchAuto.in.readUTF();

						System.out.println("MatchingNum:"+ matchingNumStr);

						if(matchingNumStr.startsWith(":")){

							dia.dismiss();
							System.out.println("---------------------dismiss-------------------");

						}						
						else if(matchingNumStr.equals("fail") || matchingNumStr == "fail"){
							handler.sendEmptyMessage(1);
						}

						//	ㅡㅡㅡㅡㅡ		자신의 위치 위도경도를 주소로 변환		ㅡㅡㅡㅡㅡ
						Geocoder coder = new Geocoder(SuccessMatching.this, Locale.KOREAN);

						try {
							addr = coder.getFromLocation(myLocation.getMyLocation().getLatitudeE6()/1000000.0, myLocation.getMyLocation().getLongitudeE6()/1000000.0, 1);
						} catch (IOException e) {
							e.printStackTrace();
						}

						myAddr = new StringBuffer(addr.get(0).getLocality()+" ");	//서울특별시
						myAddr.append(addr.get(0).getThoroughfare()+" ");			//서초2동
						myAddr.append(addr.get(0).getFeatureName());				//1333-3
						// myAddr == "서울특별시 서초동 1333-3"
						//	ㅡㅡㅡㅡㅡ		자신의 위치 위도경도를 주소로 변환		ㅡㅡㅡㅡㅡ


						//		ㅡㅡㅡㅡㅡ 		SQLite (insert) 		ㅡㅡㅡㅡㅡ
						mHelper = new DBHelper(SuccessMatching.this);

						Date now = new Date(System.currentTimeMillis());
						SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd[hh:mm]");

						SQLiteDatabase db;
						db = mHelper.getWritableDatabase();

						db.execSQL("INSERT INTO usedInfo VALUES ('"+sdf.format(now)+"', '"+myAddr+"', '"+vo.getUsedInfoCarNum()+"');");

						mHelper.close();
						//    	ㅡㅡㅡㅡㅡ 		SQLite (insert) 		ㅡㅡㅡㅡㅡ

						if(getVoice.equals("true")){

							mPlayer = MediaPlayer.create(SuccessMatching.this, R.raw.successmatching);
							mPlayer.seekTo(0);
							mPlayer.start();
						}

						try {
							while(true){
								matchingTaxiData = SearchAuto.in.readUTF();
								System.out.println(matchingTaxiData);
								//오고있는 택시 좌표에 표시
								handler.sendEmptyMessage(2);
							}
						} catch (IOException e) {
							e.printStackTrace();
						}						

						Looper.loop();

					}catch(Exception e){ 
						e.printStackTrace();
						Log.e("TCP", "C: Error1");
					}

				}catch(Exception e){
					Log.e("TCP", "Client: Error2");

				}


			}

		}

	}

	//오고있는 택시 좌표에 표시
	public void parseMatchedTaxiGeoes(String matchingTaxiData){

		//'위도:경도' 이렇게 전송됨.
		Log.d("D", matchingTaxiData);		

		String[] matchingTaxi = matchingTaxiData.split(":");

		//처음이라서 애드
		if(isAction){
			matchedTaxiGeo.add(new OverlayItem(new GeoPoint(Integer.parseInt(matchingTaxi[0]), Integer.parseInt(matchingTaxi[1])),
					"매칭된 택시", taxiNum));

			taxi = getResources().getDrawable(R.drawable.taxi);
			matchedTaxi = new MatchedTaxiOverlays(taxi);

			overlays.add(matchedTaxi);
			isAction = false;
			matchedMap.invalidate();
		}

		//처음이 아니라서 오버레이 지우고 다시 애드
		else{
			overlays.remove(1);

			matchedTaxiGeo.set(0,new OverlayItem(new GeoPoint(Integer.parseInt(matchingTaxi[0]), Integer.parseInt(matchingTaxi[1])),
					"매칭된 택시", taxiNum));

			matchedTaxi = new MatchedTaxiOverlays(taxi);
			overlays.add(matchedTaxi);
			matchedMap.invalidate();
		}

	}

	//빈 택시 오버레이클래스
	private class MatchedTaxiOverlays extends ItemizedOverlay<OverlayItem>{

		OverlayItem clickItem;
		public MatchedTaxiOverlays(Drawable arg0) {
			super(arg0);
			boundCenterBottom(arg0);			
			//createItem이 작동하게함
			populate();		
		}

		@Override
		protected OverlayItem createItem(int i) {

			return matchedTaxiGeo.get(i);
		}

		//size만큼 createItem실행
		@Override
		public int size() {
			return matchedTaxiGeo.size();
		}


	}

	//포즈
	@Override
	protected void onPause() {

		super.onPause();
		myLocation.disableMyLocation();
		myLocation.disableCompass();

		//종료시 서버에 종료라고 알림
		UsedInfoVO endVo = new UsedInfoVO();
		endVo.setMsg("end");
		endVo.setUsedInfoMachingNum(matchingNumStr);

		if(getMatch=="manual" || getMatch.equals("manual")){
			try {
				SearchManual.out.writeObject(endVo);
				SearchManual.out.flush();
			} catch (IOException e1) {
				e1.printStackTrace();
			}

			if(SearchManual.in != null){
				try {
					SearchManual.in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if(SearchManual.out != null){
				try {
					SearchManual.out.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if(SearchManual.socket != null){
				try {
					SearchManual.socket.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}

		else if(getMatch=="auto" || getMatch.equals("auto")){
			try {
				SearchAuto.out.writeObject(endVo);
				SearchAuto.out.flush();
			} catch (IOException e1) {
				e1.printStackTrace();
			}

			if(SearchAuto.in != null){
				try {
					SearchAuto.in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if(SearchAuto.out != null){
				try {
					SearchAuto.out.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if(SearchAuto.socket != null){
				try {
					SearchAuto.socket.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	@Override
	protected void onResume() {

		super.onResume();
		myLocation.enableMyLocation();
		myLocation.enableCompass();

	}

	//백키 막기
	@Override
	public void onBackPressed() {

	}

	//메뉴만들기
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);

		menu.add(0, 1, 0, "왼손잡이").setIcon(R.drawable.left);
		menu.add(0, 2, 0, "도움말").setIcon(R.drawable.information);
		menu.add(0, 3, 0, "오른손잡이").setIcon(R.drawable.right);
		return true;
	}

	//메뉴 셀렉트
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		//옵션에 저장하기 위한 도구
		SharedPreferences.Editor edit = pref.edit();

		switch(item.getItemId()){

		case 1:
			edit.putString("ui", "left");
			edit.commit();
			findViewById(R.id.myLocation).setVisibility(View.INVISIBLE);
			findViewById(R.id.myLocationLeft).setVisibility(View.VISIBLE);
			findViewById(R.id.sms).setVisibility(View.INVISIBLE);
			findViewById(R.id.smsLeft).setVisibility(View.VISIBLE);
			findViewById(R.id.end).setVisibility(View.INVISIBLE);
			findViewById(R.id.endLeft).setVisibility(View.VISIBLE);
			return true;
		case 2:
			Intent intent = new Intent(SuccessMatching.this, Help.class);
			startActivity(intent);
			return true;
		case 3:
			edit.putString("ui", "right");
			edit.commit();
			findViewById(R.id.myLocation).setVisibility(View.VISIBLE);
			findViewById(R.id.myLocationLeft).setVisibility(View.INVISIBLE);
			findViewById(R.id.sms).setVisibility(View.VISIBLE);
			findViewById(R.id.smsLeft).setVisibility(View.INVISIBLE);
			findViewById(R.id.end).setVisibility(View.VISIBLE);
			findViewById(R.id.endLeft).setVisibility(View.INVISIBLE);
			return true;
		}
		return false;
	}

}
