package app.tama;

import java.util.ArrayList;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.*;

public class UseList extends ListActivity {
	private ArrayList<String> list; 
	private ListAdapter adapter;
	private ImageButton deleteAllBtn;
	private ImageButton closeBtn;

	//	delete query where
	private String date;		
	private String addr;
	private String carNum;
	//	delete query where

	private int index;


	DBHelper mHelper; 

	@Override
	public void onCreate(Bundle savedInstanceState) {
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		super.onCreate(savedInstanceState);
		setContentView(R.layout.uselist);

		mHelper = new DBHelper(this);

		list = new ArrayList<String>();

		adapter = new ListAdapter(this, R.layout.row, list);
		SQLiteDatabase db = mHelper.getWritableDatabase();
		Cursor cursor = db.rawQuery("SELECT date, addr, carNum FROM usedInfo ORDER BY date DESC", null);

		String result = "";

		//		ㅡㅡㅡㅡㅡ 		DB data 리스트에 보이기		ㅡㅡㅡㅡㅡ
		while(cursor.moveToNext()){
			date = cursor.getString(0);
			addr = cursor.getString(1);
			carNum = cursor.getString(2);
			result = ("탑승시간 : "+date+"\n차량번호 : "+carNum+"\n탑승지역 : "+addr);

			list.add(result);
			setListAdapter(adapter); 
		}
		//		ㅡㅡㅡㅡㅡ 		DB data 리스트에 보이기		ㅡㅡㅡㅡㅡ

		cursor.close();
		mHelper.close();



		deleteAllBtn = (ImageButton)findViewById(R.id.deleteAllBtn);
		deleteAllBtn.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				new AlertDialog.Builder(UseList.this).setTitle("전체 삭제")
				.setMessage("이용내역을 전부 삭제 하시겠습니까?")
				.setPositiveButton("네", new DialogInterface.OnClickListener(){

					public void onClick(DialogInterface dialog, int which) {
						//	ㅡㅡㅡㅡㅡ		Query delete  	 	ㅡㅡㅡㅡㅡ
						SQLiteDatabase db;
						db = mHelper.getWritableDatabase();
						db.execSQL("DELETE FROM usedInfo");

						mHelper.close();
						Toast.makeText(UseList.this, "삭제완료", Toast.LENGTH_SHORT).show();

						finish();
						//	ㅡㅡㅡㅡㅡ		Query delete 	 	ㅡㅡㅡㅡㅡ
					}

				})
				.setNegativeButton("아니오", null).show();

			}
		});


		// 		ㅡㅡㅡㅡㅡ		close 	ㅡㅡㅡㅡㅡ
		closeBtn = (ImageButton)findViewById(R.id.closeBtn);
		closeBtn.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				finish();
			}
		});
		// 		ㅡㅡㅡㅡㅡ		close 	ㅡㅡㅡㅡㅡ


	}// end of onCreate()


	//	ㅡㅡㅡㅡㅡ 		ListView Custom		ㅡㅡㅡㅡㅡ
	private class ListAdapter extends ArrayAdapter<String>{
		private ArrayList<String> items;

		public ListAdapter(Context context, int textViewResourceId, ArrayList<String> items) {
			super(context, textViewResourceId, items);
			this.items = items;
		}
		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			View v = convertView;
			if (v == null) {
				LayoutInflater vi = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.row, null);
			}
			String p = items.get(position);
			if (p != null) {
				TextView tt = (TextView) v.findViewById(R.id.toptext);
				tt.setText(p.toString());                            
			}
			return v;
		}
	}
	//		ㅡㅡㅡㅡㅡ 		ListView Custom		ㅡㅡㅡㅡㅡ




	//		ㅡㅡㅡㅡㅡ		ListView Click Event		ㅡㅡㅡㅡㅡ
	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		super.onListItemClick(l, v, position, id);

		String[] splitDate = list.get(position).split("\n차량번호 : ");
		String[] splitDate1 = splitDate[0].split("탑승시간 : ");
		date = splitDate1[1];
		
		String[] splitCarNum1 = splitDate[1].split("\n탑승지역 : ");
		carNum = splitCarNum1[0];
		
		addr = splitCarNum1[1];

		index = position;

		new AlertDialog.Builder(UseList.this).setTitle("선택항목")
		.setMessage(list.get(position)+" 내용을 삭제 하시겠습니까?")
		.setPositiveButton("네", new DialogInterface.OnClickListener(){

			public void onClick(DialogInterface dialog, int which) {
//				ㅡㅡㅡㅡㅡ		Query delete  	 	ㅡㅡㅡㅡㅡ
				SQLiteDatabase db;
				db = mHelper.getWritableDatabase();
				db.execSQL("DELETE FROM usedInfo WHERE date='"+date+
						"' AND addr='"+addr+"' AND carNum='"+carNum+"';");

				Toast.makeText(UseList.this, "삭제완료", Toast.LENGTH_SHORT).show();
				
				mHelper.close();

				list.remove(index);
				adapter.notifyDataSetChanged();
				//	ㅡㅡㅡㅡㅡ		Query delete 	 	ㅡㅡㅡㅡㅡ
			}

		})
		.setNegativeButton("아니오", null).show();


	}
	//		ㅡㅡㅡㅡㅡ		ListView Click Event		ㅡㅡㅡㅡㅡ

}

//ㅡㅡㅡㅡㅡ 		SQLite 		ㅡㅡㅡㅡㅡ
class DBHelper extends SQLiteOpenHelper{

	public DBHelper(Context context) {
		super(context, "SQLite.db", null, 1);
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		db.execSQL("CREATE TABLE usedInfo (date TEXT, addr TEXT, carNum TEXT);");
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		db.execSQL("DROP TABLE IF EXISTS usedInfo");
		onCreate(db);
	}
}
//ㅡㅡㅡㅡㅡ 		SQLite 		ㅡㅡㅡㅡㅡ